PyCoder6 - The LightWare Python IDE based on Qt6
=====
   Developing by Charles K Barcza (**blackPanther Project** - <a href="http://blackpanther.hu">blackpanther.hu</a>)
   - Credits: Harrison Amoatey, Miklos Horvath
   
##  Python IDE (Python3/Qt6)

PyCoder seeks to simplify the process of development in python3 by means of:

1. A simple and intuitive UI ( Zero clutter )
1. Utilization of very powerful open source libraries
1. Implementation of carefully chosen features
1. Support for other file formats that commonly accompany python development
1. Python, Xml, Css, Html, Txt, etc. edit support 

###  Features:
1. Builds source code into executable with Cx_Freeze (PyInstaller planned)
1. Refactoring
1. Project Management
1. Go-to-Definition
1. Snippets
1. Support for syntax coloring for XML, HTML and CSS
1. Error Analysis
1. Pycodestyle checker and fixer
1. Auto-completion
1. Outline Explorer
1. Profiler
1. Find-in-Files/Replace
1. Code Library
1. Split Editor ( Horizontal and Vertical )
1. MiniMap (optional) instead vertical scrollbar
1. Etc.

### Download
   Click on [<a href='https://github.com/blackPantherOS/PyCoder/releases'>Release</a>] to view available downloads.

### Dependencies:
1. Python 3 ( for running programs )
1. PyQt6 ( if you are running from source )
1. see requirements.txt 
   
Then perhaps:
* Pywin32 for windows ( for stamping executables if you are running from source )

### License:
* GPL v3

### Latest version:

** <a href='https://github.com/blackPantherOS/PyCoder/releases'>0.5.x</a>
  
### Icon
![Alt text](pycoder.svg "PyCoder Icon")

### Screenshots
![Alt text](/Resources/screenshots/PyCoder6.png "PyCoder6 running without Minimap blackPanther OS v24.1")
![Alt text](/Resources/screenshots/pycoder2.png "PyCoder running with Minimap blackPanther OS v24.1")

